program Skrivnost; { RTK 2008.1.5 }

function AliObstajaZaporedjeKlicev(a, b: integer): boolean;
const n = 10000;
var Obvescen: array [0..n - 1] of boolean; u, v: integer;
begin
  for u := 0 to n - 1 do Obvescen[u] := false;
  Obvescen[a] := true;
  while not EOF do begin
    ReadLn(u, v);
    if Obvescen[u] then Obvescen[v] := true;
    if Obvescen[v] then Obvescen[u] := true;
    if Obvescen[b] then break;
  end; {while}
  AliObstajaZaporedjeKlicev := Obvescen[b];
end; {AliObstajaZaporedjeKlicev}

procedure NajkrajseZaporedjeKlicev(a, b: integer);
const n = 10000;
var StKlicev, Predhodnik, Zaporedje: array [0..n - 1] of integer; u, v: integer;
begin
  for u := 0 to n - 1 do StKlicev[u] := n;
  StKlicev[a] := 0; Predhodnik[a] := a;
  while not EOF do begin
    ReadLn(u, v);
    if StKlicev[v] > StKlicev[u] + 1 then 
      begin StKlicev[v] := StKlicev[u] + 1; Predhodnik[v] := u end;
    if StKlicev[u] > StKlicev[v] + 1 then 
      begin StKlicev[u] := StKlicev[v] + 1; Predhodnik[u] := v end;
  end; {while}
  if StKlicev[b] = n then WriteLn(b, ' ni dobil informacije od ', a, '.')
  else begin
    u := b;
    repeat
      Zaporedje[StKlicev[u]] := u;
      u := Predhodnik[u];
    until u = a;
    Zaporedje[0] := a;
    WriteLn('Zaporedje ', StKlicev[b], ' pogovorov od ', a, ', do ', b, ':');
    for u := 1 to StKlicev[b] do
      WriteLn('- oseba ', Zaporedje[u - 1], ' pove osebi ', Zaporedje[u]);
  end; {if}
end; {NajkrajseZaporedjeKlicev}

procedure Pomoc;
begin
  WriteLn('Sintaksa: rtk08s1n5 {a|b} xxxx yyyy');
  WriteLn('xxxx, yyyy = dve telefonski tevilki');
  WriteLn('a ali b = oznaka podnaloge');
end; {Pomoc}

var a, b, i: integer;
begin {Skrivnost}
  if ParamCount <> 3 then begin Pomoc; exit end;
  Val(ParamStr(2), a, i); Val(ParamStr(3), b, i);
  if ParamStr(1) = 'a' then WriteLn('AliObstajaZaporedjeKlicev(', a, ', ', b, ') = ', AliObstajaZaporedjeKlicev(a, b))
  else NajkrajseZaporedjeKlicev(a, b);
end. {Skrivnost}