program Spageti; { RTK 2008.3.3 - reitev s tabelo po dolinah }
const MaxN = 1000000; MaxD = 1000000;
type TabelaT = packed array [0..MaxD] of integer;
var
  T: ^TabelaT;
  n, b, i, m, d, dNaj: integer;
  mi, di: array [1..MaxN] of integer;
  F: text;
begin
  { Preberimo vhodne podatke. }
  if ParamCount > 0 then Assign(F, ParamStr(1)) else Assign(F, 'spageti.in');
  Reset(F); ReadLn(F, n, b);
  dNaj := 0; 
  for i := 1 to n do begin
    ReadLn(F, mi[i], di[i]); 
    if di[i] > dNaj then dNaj := di[i];
  end; {for i}
  dNaj := dNaj + 1;
  { Pripravimo tabelo s tevilom pagetov za vsako dolino. }
  GetMem(T, sizeof(integer) * dNaj);
  for i := 1 to dNaj - 1 do T^[i] := 0;
  for i := 1 to n do T^[di[i]] := T^[di[i]] + mi[i];
  { Lomimo pagete. }
  d := dNaj - 1;
  while d > 2 do begin
    m := T^[d];
    if m > 0 then begin
      { Imamo m pagetov doline d; prelomimo jih. }
      if m > b then break; { Preve jih je. }
      b := b - m;
      T^[d div 2] := T^[d div 2] + m;
      T^[(d + 1) div 2] := T^[(d + 1) div 2] + m;
    end; {if}
    d := d - 1;
  end; {while}
  FreeMem(T, sizeof(integer) * dNaj);
  { Izpiimo rezultat. }
  if ParamCount > 0 then Assign(F, ParamStr(2)) else Assign(F, 'spageti.out');
  Rewrite(F); WriteLn(F, d); Close(F);
end. {Spageti}
