#include <stdio.h> /* RTK 2008.3.3 */
#include <stdbool.h>

#define MaxN 1000000
int mi[MaxN], di[MaxN], mi2[2 * MaxN + 1], di2[2 * MaxN + 1];

int main(int argc, char **argv)
{
	int n, b, i, j, d, d2, m, m2, i2, j2, n2, qMod; bool iz2;

	/* Preberimo vhodne podatke. */
	FILE *f = fopen(argc > 1 ? argv[1] : "spageti.in", "rt");
	fscanf(f, "%d %d", &n, &b);
	for (i = 0, j = 0; i < n; i++)
	{
		fscanf(f, "%d %d", &mi[j], &di[j]);
		if (j > 0 && di[j] == di[j - 1]) /* ve katel enake doline zdruimo */
			{ mi[j - 1] += mi[j]; continue; }
		j++;
	}
	n = j; qMod = 2 * n + 1; /* najveja mona dolina seznama S' */

	/* Lomimo pagete. */
	i2 = 1; j2 = 0; n2 = 0;
	for ( ; ; )
	{
		/* V katerem seznamu je najdalja katla, S ali S'? */
    	if (n2 <= 0) iz2 = false;
    	else if (j <= 0) iz2 = true;
    	else iz2 = (di2[i2] >= di[j - 1]);
    	if (! iz2) /* Lomimo najdaljo katlo iz S. */
    		{ j--; m = mi[j]; d = di[j]; }
    	else { /* Lomimo najdaljo katlo iz S'. */
    		m = mi2[i2]; d = di2[i2]; i2 = (i2 + 1) % qMod; n2--;
			/* e so enako dolgi pageti tudi v S, bomo v isti sapi lomili e njih. */
			if (j > 0 && di[j - 1] == d) m += mi[--j]; }
		if (d == 1 || m > b) break; /* ne moremo prelomiti te skupine */
		b -= m;

		/* Prelomili smo m pagetov doline d.  Nastane skupina m2 pagetov doline d2. */
		d2 = (d + 1) / 2; if (d & 1) m2 = m; else m2 = 2 * m;
		/* Mogoe je na koncu S' e katla za to dolino. */
		if (n2 > 0 && di2[j2] == d2) mi2[j2] += m2;
		else { /* e pa ni, dodajmo zdaj novo katlo. */
			j2 = (j2 + 1) % qMod; mi2[j2] = m2; di2[j2] = d2; n2++; }
		/* e je bil d lih, nastane e ena skupina malo krajih pagetov doline d / 2. */
		if (d & 1) { /* Ta bo zagotovo potrebovala novo katlo. */
			d2 = d / 2; j2 = (j2 + 1) % qMod;
			mi2[j2] = m2; di2[j2] = d2; n2++; }
	}

	/* Izpiimo rezultat. */
	f = fopen(argc > 2 ? argv[2] : "spageti.out", "wt");
	fprintf(f, "%d\n", d); fclose(f); return 0;
}
